<?php

/**
 * webEdition CMS
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package    webEdition_language
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
/**
 * Language file: prefs.inc.php
 * Provides language strings.
 * Language: English
 */
$l_prefs = array(
		/*		 * ***************************************************************************
		 * PRELOAD
		 * *************************************************************************** */

		'preload' => "Ladataan asetuksia, hetkinen ...",
		'preload_wait' => "Ladataan asetuksia",
		/*		 * ***************************************************************************
		 * SAVE
		 * *************************************************************************** */

		'save' => "Tallennetaan asetuksia, hetkinen ...",
		'save_wait' => "Tallennetaan asetuksia",
		'saved' => "Asetukset on tallennettu.",
		'saved_successfully' => "Asetukset tallennettu",
		/*		 * ***************************************************************************
		 * TABS
		 * *************************************************************************** */

		'tab_ui' => "Kyttjrajapinta",
		'tab_glossary' => "Sanasto",
		'tab_extensions' => "Tiedoston pte",
		'tab_editor' => 'Editori',
		'tab_formmail' => 'Formmail',
		'formmail_recipients' => 'Formmail -vastaanottajat',
		'tab_proxy' => 'Proxy -palvelin',
		'tab_advanced' => 'Lisasetukset',
		'tab_system' => 'Jrjestelm',
		'tab_seolinks' => 'SEO links', // TRANSLATE
		'tab_error_handling' => 'Virheksittely',
		'tab_cockpit' => 'Pika-aloitus',
		'tab_cache' => 'Vlimuisti',
		'tab_language' => 'Kielet',
		'tab_countries' => 'Countries', // TRANSLATE
		'tab_modules' => 'Moduulit',
		'tab_versions' => 'Versiointi',
		/*		 * ***************************************************************************
		 * USER INTERFACE
		 * *************************************************************************** */
		/**
		 * Countries
		 */
		'countries_information' => "Select the countries, which are available in the customer module, shop-module and so on.", // TRANSLATE
		'countries_headline' => "Country selection", // TRANSLATE
		'countries_country' => "Country", // TRANSLATE
		'countries_top' => "top list", // TRANSLATE
		'countries_show' => "display", // TRANSLATE
		'countries_noshow' => "no display", // TRANSLATE

		/**
		 * LANGUAGE
		 */
		'choose_language' => "Kieli",
		'language_notice' => "Kielenmuutos tulee voimaan webEditionin uudelleenkynnistyksen jlkeen.",
		/**
		 * CHARSET
		 */
		'default_charset' => "Standard charset", // TRANSLATE

		/**
		 * SEEM
		 */
		'seem' => "Helppokytttila",
		'seem_deactivate' => "Disabloi helppokytttila",
		'seem_startdocument' => "Helppokytttilan aloitussivu",
		'seem_start_type_document' => "Dokumentti",
		'seem_start_type_object' => "Objekti",
		'seem_start_type_cockpit' => "Pika-aloitus",
		'question_change_to_seem_start' => "Haluatko siirty valittuun dokumenttiin?",
		/**
		 * Sidebar
		 */
		'sidebar' => "Sivupalkki",
		'sidebar_deactivate' => "poista kytst",
		'sidebar_show_on_startup' => "nyt alussa",
		'sidebar_width' => "Leveys pikseleiss",
		'sidebar_document' => "Dokumentti",
		/**
		 * WINDOW DIMENSION
		 */
		'dimension' => "Ikkunan koko",
		'maximize' => "Maksimoi",
		'specify' => "Mrit",
		'width' => "Leveys",
		'height' => "Korkeus",
		'predefined' => "Esiasetetut koot",
		'show_predefined' => "Nyt esiasetetut koot",
		'hide_predefined' => "Piilota esiasetetut koot",
		/**
		 * TREE
		 */
		'tree_title' => "Puunkym",
		'all' => "Kaikki",
		/*		 * ***************************************************************************
		 * FILE EXTENSIONS
		 * *************************************************************************** */

		/**
		 * FILE EXTENSIONS
		 */
		'extensions_information' => "Mrit staattisten ja dynaamisten dokumenttien oletusptteet tlt.",
		'we_extensions' => "webEdition -sivujen pte",
		'static' => "Staattiset sivut",
		'dynamic' => "Dynaamiset sivut",
		'html_extensions' => "HTML -sivujen pte",
		'html' => "HTML -sivut",
		/*		 * ***************************************************************************
		 * Glossary
		 * *************************************************************************** */

		'glossary_publishing' => "Tarkista ennen julkaisua",
		'force_glossary_check' => "Pakota sanastotarkistus",
		'force_glossary_action' => "Pakota toiminta",
		/*		 * ***************************************************************************
		 * COCKPIT
		 * *************************************************************************** */

		/**
		 * Cockpit
		 */
		'cockpit_amount_columns' => "Sarakkeita pika-aloituksessa ",
		/*		 * ***************************************************************************
		 * CACHING
		 * *************************************************************************** */

		/**
		 * Cache Type
		 */
		'cache_information' => "Aseta uusien sivupohjien oletusarvot kentille \"Vlimuistin tyyppi\" ja \"Vlimuistin elinik\".<br /><br />Huomioi ett nm ovat vain esivalinnat.",
		'cache_navigation_information' => "Aseta oletusarvot &lt;we:navigation&gt; tageille. Tm arvo voidaan ylikirjoittaa \"cachelifetime\" attribuutilla &lt;we:navigation&gt; tagissa.",
		'cache_presettings' => "Oletusarvot",
		'cache_type' => "Vlimuistin tyyppi",
		'cache_type_none' => "Vlimuisti pois kytst",
		'cache_type_full' => "Tysi vlimuisti",
		'cache_type_document' => "Dokumentin vlimuisti",
		'cache_type_wetag' => "we:Tagien vlimuisti",
		/**
		 * Cache Life Time
		 */
		'cache_lifetime' => "Vlimuistin elinik sekunneissa",
		'cache_lifetimes' => array(
				0 => "",
				60 => "1 minuutti",
				300 => "5 minuuttia",
				600 => "10 minuuttia",
				1800 => "30 minuuttia",
				3600 => "1 tunti",
				21600 => "6 tuntia",
				43200 => "12 tuntia",
				86400 => "1 vuorokausi",
		),
		'delete_cache_after' => 'Tyhjenn vlimuisti jlkeen',
		'delete_cache_add' => 'lisyksen jlkeen',
		'delete_cache_edit' => 'muutoksen jlkeen',
		'delete_cache_delete' => 'poiston jlkeen',
		'cache_navigation' => 'Oletusasetus',
		'default_cache_lifetime' => 'Vlimuistin oletuselinik',
		/*		 * ***************************************************************************
		 * LOCALES // LANGUAGES
		 * *************************************************************************** */

		/**
		 * Languages
		 */
		'locale_information' => "Lis kaikki kielet joilla haluat tarjota web-sivuja.<br /><br />Tt asetusta kytetn sanastotarkastuksessa ja oikoluvussa.",
		'locale_languages' => "Kieli",
		'locale_countries' => "Maa",
		'locale_add' => "Lis kieli",
		'cannot_delete_default_language' => "Oletuskielt ei voi poistaa.",
		'language_already_exists' => "Tm kieli on jo olemassa",
		'language_country_missing' => "Please select also a country", // TRANSLATE
		'add_dictionary_question' => "Haluatko pivitt sanaston tlle kielelle?",
		'langlink_headline' => "Support for setting links between different languages",
		'langlink_information' => "With this option, you can set the links to corresponding language versions of documents/objects in the backend and open/create etc. these documents/oobjects.<br/>For the frontend you can display these links in a listview type=languagelink.<br/><br/>For folders, you can define a <b>document</b> in each language, which is used if for a document within the folder no corresponding document in the other language is set.",
		'langlink_support' => "active",
		'langlink_support_backlinks' => "Generate back links automatically",// TRANSLATE
		'langlink_support_backlinks_information' => "Back links can be generated automatically for documents/objects (not folders). The other document should not be open in an editor tab!",
		'langlink_support_recursive' => "Generate language links recursive",// TRANSLATE
		'langlink_support_recursive_information' => "Setting of langauge links can be done recursively for documents/objects (but not folders). This sets all possible links and tries to establish the language-circle as fast as possible. The other documents should not be open in an editor tab!",
		/*		 * ***************************************************************************
		 * EDITOR
		 * *************************************************************************** */

		/**
		 * EDITOR PLUGIN
		 */
		'editor_plugin' => 'Editori PlugIn',
		'use_it' => "Kyt",
		'start_automatic' => "Kynnist automaattisesti",
		'ask_at_start' => 'Kysy alussa<br>mit editoria kytetn',
		'must_register' => 'Vaatii rekisterinnin',
		'change_only_in_ie' => 'Nit asetuksia ei voi muuttaa. Editor -plugIn toimii ainoastaan windows-version Internet Explorer, Mozilla, Firebird -ja Firefox selaimissa.',
		'install_plugin' => 'Jotta Editor PlugIn -laajennusta voidaan kytt Mozillan ActiveX Plugin on asennettava.',
		'confirm_install_plugin' => 'Mozillan ActiveX PlugIn sallii Mozillan kyttvn ActiveX -laajennuksia. Asennuksen jlkeen selain on suljettava ja avattava uudelleen.\\n\\nHuomautus: ActiveX voi olla turvallisuusriski!\\n\\nJatketaanko asennusta?',
		'install_editor_plugin' => 'Kyttksesi webEdition -jrjestelmn editori plugin laajennusta sinun on asennettava se.',
		'install_editor_plugin_text' => 'Asennetaan webEdition editori plugin laajennusta...',
		/**
		 * TEMPLATE EDITOR
		 */
		'editor_information' => "Mrit fonttikoko jota haluat kytt sivupohjien, CSS-tiedostojen ja JavaScript-tiedostojen muokkaamiseen webEditionissa.<br /><br />Asetusta kytetn kaikille yllmainituille tiedostotyypeille.",
		'editor_mode' => 'Editori',
		'editor_font' => 'Editorin kirjasin',
		'editor_fontname' => 'Kirjasimen nimi',
		'editor_fontsize' => 'Koko',
		'editor_dimension' => 'Editorin koko',
		'editor_dimension_normal' => 'Oletus',
		/*		 * ***************************************************************************
		 * FORMMAIL RECIPIENTS
		 * *************************************************************************** */

		/**
		 * FORMMAIL RECIPIENTS
		 */
		'formmail_information' => "Syt kaikki shkpostiosoitteet, jotka voivat vastaanottaa formmail -funktion lhettmi lomakkeita (&lt;we:form type=\"formmail\" ..&gt;).<br><br>Jos et syt shkpostiosoitetta, et voi lhett lomakkeita kyttmll formmail -funktiota!",
		'formmail_log' => "Formmailin loki",
		'log_is_empty' => "Loki on tyhj!",
		'ip_address' => "IP osoite",
		'blocked_until' => "Estetty asti",
		'unblock' => "Pura esto",
		'clear_log_question' => "Halutako varmasti tyhjent lokin?",
		'clear_block_entry_question' => "Haluatko varmasti purkaa eston IP-osoitteilta: %s ?",
		'forever' => "Aina",
		'yes' => "kyll",
		'no' => "ei",
		'on' => "pll",
		'off' => "pois",
		'formmailConfirm' => "Formmail varmistustoiminto",
		'logFormmailRequests' => "Formmail pyynnt lokiin",
		'deleteEntriesOlder' => "Poista vanhemmat merkinnt",
		'blockFormmail' => "Rajoita formmail pyyntj",
		'formmailSpan' => "Aikavlill",
		'formmailTrials' => "Pyyntj sallittu",
		'blockFor' => "Est ajaksi",
		'formmailViaWeDoc' => "Call formmail via webEdition-Dokument.",
		'never' => "ei koskaan",
		'1_day' => "1 piv",
		'more_days' => "%s piv",
		'1_week' => "1 viikko",
		'more_weeks' => "%s viikkoa",
		'1_year' => "1 vuosi",
		'more_years' => "%s vuotta",
		'1_minute' => "1 minuutti",
		'more_minutes' => "%s minuuttia",
		'1_hour' => "1 tunti",
		'more_hours' => "%s tuntia",
		'ever' => "aina",
		/*		 * ***************************************************************************
		 * PROXY SERVER
		 * *************************************************************************** */

		/**
		 * PROXY SERVER
		 */
		'proxy_information' => "Jos palvelimesi kytt Proxy-palvelinta, mrittele sen asetukset tll.",
		'useproxy' => "Kyt proxy-palvelinta<br>Live-pivityksess",
		'proxyaddr' => "Osoite",
		'proxyport' => "Portti",
		'proxyuser' => "Kyttjnimi",
		'proxypass' => "Salasana",
		/*		 * ***************************************************************************
		 * ADVANCED
		 * *************************************************************************** */

		/**
		 * ATTRIBS
		 */
		'default_php_setting' => "Oletusasetukset <br><em>php</em>-mreille we:tageissa",
		/**
		 * INLINEEDIT
		 */
		'inlineedit_default' => "Oletusarvo<br><em>inlineedit</em> mreelle<br>&lt;we:textarea&gt; -tagissa",
		'removefirstparagraph_default' => "Default value for the<br><em>removefirstparagraph</em> attribute in<br>&lt;we:textarea&gt;", // TRANSLATE
		'hidenameattribinweimg_default' => "No output of name=xyz in we:img (HTML 5)", // TRANSLATE
		'hidenameattribinweform_default' => "No output of name=xyz in we:form (XHTML strict)", // TRANSLATE

		/**
		 * SAFARI WYSIWYG
		 */
		'safari_wysiwyg' => "Kyt Safari Wysiwyg<br>editoria (beta versio)",
		/**
		 * SHOWINPUTS
		 */
		'showinputs_default' => "Tagin &lt;we:img&gt; oletusarvo mreelle <br><em>showinputs</em>",
		/**
		 * NAVIGATION
		 */
		'navigation_entries_from_document' => "Create new navigation entries from the document as", // TRANSLATE
		'navigation_entries_from_document_item' => "item", // TRANSLATE
		'navigation_entries_from_document_folder' => "folder", // TRANSLATE
		'navigation_rules_continue' => "Continue to evaluate navigation rules after a first match", // TRANSLATE
		'general_directoryindex_hide' => "Hide DirectoryIndex- file names", // TRANSLATE
		'general_directoryindex_hide_description' => "For the tags <we:link>, <we:linkslist>, <we:listview> you can use the attribute 'hidedirindex'", // TRANSLATE
		'navigation_directoryindex_hide' => "in the navigation output", // TRANSLATE
		'wysiwyglinks_directoryindex_hide' => "in links from the WYSIWYG editor", // TRANSLATE
		'objectlinks_directoryindex_hide' => "in links to objects", // TRANSLATE
		'urlencode_objectseourls' => "URLencode the SEO-urls",// TRANSLATE
		'suppress404code' => "suppress 404 not found",// TRANSLATE
		'navigation_directoryindex_description' => "After a change, a rebuild is required (i.e. navigation cache, objects ...)", // TRANSLATE
		'navigation_directoryindex_names' => "DirectoryIndex file names (comma separated, incl. file extensions, i.e. 'index.php,index.html'", // TRANSLATE
		'general_objectseourls' => "Generate object SEO urls ", // TRANSLATE
		'navigation_objectseourls' => "in the navigation output", // TRANSLATE
		'wysiwyglinks_objectseourls' => "in links from the WYSIWYG editor", // TRANSLATE
		'general_objectseourls_description' => "For the tags <we:link>, <we:linklist>, <we:listview>, <we:object> you can use the attribute 'objectseourls'", // TRANSLATE
		'taglinks_directoryindex_hide' => "preset value for tags", // TRANSLATE
		'taglinks_objectseourls' => "preset value for tags", // TRANSLATE
		'general_seoinside' => "Usage within webEdition ", // TRANSLATE
		'general_seoinside_description' => "If DirectoryIndex- file names and object SEO urls are used within webEdition, webEdition can not identify internal links and clicks on these links do not open the editor. With the following options, you can decide if they are are used in editmode and in the preview.", // TRANSLATE
		'seoinside_hideinwebedition' => "Hide in preview", // TRANSLATE
		'seoinside_hideineditmode' => "Hide in editmode", // TRANSLATE

		'navigation' => "Navigation", // TRANSLATE


		/**
		 * DATABASE
		 */
		'db_connect' => "Tietokannan<br>yhteystyyppi",
		'db_set_charset' => "Yhteyden merkist",
		'db_set_charset_information' => "The connection charset is used for the communication between webEdition and datase server.<br/>If no value is specified, the standard connection charset set in PHP is used.<br/>In the ideal case, the webEdition language (i.e. English_UTF-8), the database collation (i.e. utf8_general_ci), the connection charset (i.e. utf8) and the settings of external tools such as phpMyAdmin (i.e. utf-8) are identical. In this case, one can edit database entries with these external tools without problems.", // TRANSLATE
		'db_set_charset_warning' => "The connection charset should be changed only in a fresh installation of webEdition (without data in the database). Otherwise, all non ASCII characters will be interpreted wrong and may be destroyed.", // TRANSLATE

		/**
		 * HTTP AUTHENTICATION
		 */
		'auth' => "HTTP autentikointi",
		'useauth' => "Palvelin kytt HTTP<br>autentikointia webEdition<br>hakemistossa",
		'authuser' => "Kyttjnimi",
		'authpass' => "Salasana",
		/**
		 * THUMBNAIL DIR
		 */
		'thumbnail_dir' => "Esikatselukuvien hakemisto",
		'pagelogger_dir' => "pageLogger hakemisto",
		/**
		 * HOOKS //TRANS
		 */
		'hooks' => "\"Koukut\"",
		'hooks_information' => "\"Koukkujen\" kytt mahdollistaa mielivaltaisen PHP-koodin suorittamisen webEditionissa tallennuksen, julkaisun, julkaisun poiston sek mink tahansa sislttyypin poiston yhteydess.<br />
	Lis tietoa lytyy Online-dokumentaatiosta.<br /><br />Salli koukkujen kytt?",
		/**
		 * Backward compatibility
		 */
		'backwardcompatibility' => "Backward compatibility", //TRANSLATE
		'backwardcompatibility_tagloading' => "Load all 'old' we_tag functions", //TRANSLATE
		'backwardcompatibility_tagloading_message' => "Only necessary if in custom_tags or in PHP code inside templates we_tags are called in the form we_tag_tagname().<br/> Recommended call: we_tag<br/>('tagname',&#36;attribs,&#36;content)", //TRANSLATE


		/*		 * ***************************************************************************
		 * ERROR HANDLING
		 * *************************************************************************** */


		'error_no_object_found' => 'Virhesivu objekteille joita ei ole',
		/**
		 * TEMPLATE TAG CHECK
		 */
		'templates' => "Sivupohjat",
		'disable_template_tag_check' => "Poista puuttuvien,<br />we:lopetustagien tarkistus",
		/**
		 * ERROR HANDLER
		 */
		'error_use_handler' => "Kyt webEdition -jrjestelmn <br>virheenksittely",
		/**
		 * ERROR TYPES
		 */
		'error_types' => "Ksittele virhetyypit",
		'error_notices' => "Ilmoitukset",
		'error_deprecated' => "deprecated Notices", //TRANSLATE
		'error_warnings' => "Varoitukset",
		'error_errors' => "Virheet",
		'error_notices_warning' => 'Ominaisuus kehittjille! l aktivoi tuotantokytss!.',
		/**
		 * ERROR DISPLAY
		 */
		'error_displaying' => "Virheiden ksittelytapa",
		'error_display' => "Nyt virheet",
		'error_log' => "Kirjaa virheet Lokikirjaan",
		'error_mail' => "Lhet virheet shkpostilla",
		'error_mail_address' => "Osoite",
		'error_mail_not_saved' => 'Virheit ei lhetet annettuun shkpostiosoitteeseen, koska osoite on virheellinen!\n\nJljellolevat asetukset on tallennettu.',
		/**
		 * DEBUG FRAME
		 */
		'show_expert' => "Nyt asiantuntija-asetukset",
		'hide_expert' => "Piilota asiantuntija-asetukset",
		'show_debug_frame' => "Nyt seuranta -kehys",
		'debug_normal' => "Normaalitilassa",
		'debug_seem' => "Helppokytttilassa",
		'debug_restart' => "Muutokset vaativat uudelleenkirjautumisen",
		/*		 * ***************************************************************************
		 * MODULES
		 * *************************************************************************** */

		/**
		 * OBJECT MODULE
		 */
		'module_object' => "Tietokanta/Objektimoduuli",
		'tree_count' => "Nytettvien objektien mr",
		'tree_count_description' => "Tm arvo mritt nytettvien objektien maksimimrn vasemmassa tiedostolistassa.",
		/*		 * ***************************************************************************
		 * BACKUP
		 * *************************************************************************** */
		'backup' => "Varmuuskopio",
		'backup_slow' => "Hidas",
		'backup_fast' => "Nopea",
		'performance' => "Tss voit mritt suoritustason. Suoritustaso riippuu palvelinjrjestelmst. Jos jrjestelmss on rajattu mr resursseja (muisti, aikakatkaisu jne...) valitse hidas taso, muussa tapauksessa nopea taso.",
		'backup_auto' => "Automaattinen",
		/*		 * ***************************************************************************
		 * Validation
		 * *************************************************************************** */
		'validation' => 'Validointi',
		'xhtml_default' => 'Tagien <em>xml</em> mreen oletusarvo',
		'xhtml_debug_explanation' => 'XHTML -debug tila tukee kehityst validille xhtml -muotoiselle www-sivulle. Jokaisen we:tagin validiteetti tarkistetaan ja vrt mreet nytetn tai poistetaan. Huomioi: Tm toiminto voi kest, siksi debug tilaa kannattaa kytt ainoastaan kehitystyn aikana.',
		'xhtml_debug_headline' => 'XHTML debugtila',
		'xhtml_debug_html' => 'Aktivoi XHTML debugtila',
		'xhtml_remove_wrong' => 'Poista virheelliset mreet',
		'xhtml_show_wrong_headline' => 'Ilmoita virheellisist mreist',
		'xhtml_show_wrong_html' => 'Aktivoi',
		'xhtml_show_wrong_text_html' => 'Tekstin',
		'xhtml_show_wrong_js_html' => 'Javascript -varoituksena',
		'xhtml_show_wrong_error_log_html' => 'error logissa (PHP)',
		/*		 * ***************************************************************************
		 * max upload size
		 * *************************************************************************** */
		'we_max_upload_size' => "Maksimi latauskoko,<br>joka nytetn vihjeiss",
		'we_max_upload_size_hint' => "(MB, 0=automaattinen)",
		/*		 * ***************************************************************************
		 * we_new_folder_mod
		 * *************************************************************************** */
		'we_new_folder_mod' => "Oikeudet<br>uusille hakemistoille",
		'we_new_folder_mod_hint' => "(oletus on 755)",
		/*		 * ***************************************************************************
		 * we_doctype_workspace_behavior
		 * *************************************************************************** */

		'we_doctype_workspace_behavior_hint0' => "Dokumentin oletushakemiston tytyy sijaita kyttjn tytilassa, jotta kyttj voi valita dokumentin tyypin.",
		'we_doctype_workspace_behavior_hint1' => "Kyttjn tytilan on ssijaittava kyttjlle mritetyn dokumenttityypin oletushakemistossa, jotta dokumenttia voidaan muokata.",
		'we_doctype_workspace_behavior_1' => "Knteinen",
		'we_doctype_workspace_behavior_0' => "Standardi",
		'we_doctype_workspace_behavior' => "Dokumenttityypin kyttytyminen",
		/*		 * ***************************************************************************
		 * jupload
		 * *************************************************************************** */

		'use_jupload' => 'Kyt javaa tiedostojen lhetyksess',
		/*		 * ***************************************************************************
		 * message_reporting
		 * *************************************************************************** */
		'message_reporting' => array(
				'information' => "Voit mritt alla olevilla laatikoilla haluatko saada ilmoituksen webEditionin tapahtumista.",
				'headline' => "Ilmoitukset",
				'show_notices' => "Nyt huomautukset",
				'show_warnings' => "Nyt varoitukset",
				'show_errors' => "Nyt virheet",
		),
		/*		 * ***************************************************************************
		 * Module Activation
		 * *************************************************************************** */
		'module_activation' => array(
				'information' => "Tll voit aktivoida ja deaktivoida moduuleja tarpeesi mukaan.<br />Deaktivoidut moduulit voivat parantaa webEditionin yleist suorituskyky.",
				'headline' => "Moduulien aktivointi",
		),
		/*		 * ***************************************************************************
		 * Email settings
		 * *************************************************************************** */

		'mailer_information' => "Sd lhettk webEdition shkpostit PHP:n mail()-funktiolla vai erillisell SMTP-palvelimella.<br /><br />SMTP-palvelinta kytettess, viestien spmmiksi tulkitsemisen riski laskee.",
		'mailer_type' => "Mailerin tyyppi",
		'mailer_php' => "Kyt php mail() funktiota",
		'mailer_smtp' => "Kyt SMTP palvelinta",
		'email' => "E-Mail",
		'tab_email' => "E-Mail",
		'smtp_auth' => "Autentikaatio",
		'smtp_server' => "SMTP palvelin",
		'smtp_port' => "SMTP portti",
		'smtp_username' => "Kyttjtunnus",
		'smtp_password' => "Salasana",
		'smtp_halo' => "SMTP helo",
		'smtp_timeout' => "SMTP aikakatkaisu",
		'smtp_encryption' => "encrypted transport", // TRANSLATE
		'smtp_encryption_none' => "no", // TRANSLATE
		'smtp_encryption_ssl' => "SSL", // TRANSLATE
		'smtp_encryption_tls' => "TLS", // TRANSLATE


		/*		 * ***************************************************************************
		 * Versions settings
		 * *************************************************************************** */

		'versioning' => "Versiointi",
		'version_all' => "kaikki",
		'versioning_activate_text' => "Valitse mille sislttyypeille versiointi aktivoidaan.",
		'versioning_time_text' => "Mrittelemll aikajakson voit valita mist vanhemmat versiot poistetaan automaattisesti.",
		'versioning_time' => "Aikajakso",
		'versioning_anzahl_text' => "Luotavien versioiden mr jokaisesta dokumentista tai objektista.",
		'versioning_anzahl' => "Numero",
		'versioning_wizard_text' => "Poista tai palauta versioita avaamalla Versio-Velho.",
		'versioning_wizard' => "Avaa Versio-Velho",
		'ContentType' => "Sislttyyppi",
		'versioning_create_text' => "Mrittele mitk tapahtumat luovat uusia versioita. Joko ainoastaan julkaistaessa tai mys tallentaessa, poistaessa, poistaessa julkaisusta sek tuonnissa.",
		'versioning_create' => "Luo Versio",
		'versions_create_publishing' => "vain julkaistaessa",
		'versions_create_always' => "aina",
		'versioning_templates_text' => "Define special values for the <b>versioning of templates</b>", // TRANSLATE
		'versions_create_tmpl_publishing' => "only using special button", // TRANSLATE
		'versions_create_tmpl_always' => "always", // TRANSLATE


		'use_jeditor' => "Kyt",
		'editor_font_colors' => 'Mrittele fontin vrit',
		'editor_normal_font_color' => 'Oletus',
		'editor_we_tag_font_color' => 'webEdition tagit',
		'editor_we_attribute_font_color' => 'webEdition mreet',
		'editor_html_tag_font_color' => 'HTML tagit',
		'editor_html_attribute_font_color' => 'HTML mreet',
		'editor_pi_tag_font_color' => 'PHP koodi',
		'editor_comment_font_color' => 'Kommentit',
		'editor_highlight_colors' => 'Highlighting colors', // TRANSLATE
		'editor_linenumbers' => 'Line numbers', // TRANSLATE
		'editor_completion' => 'Code Completion', // TRANSLATE
		'editor_tooltips' => 'Tooltips on we:tags', // TRANSLATE
		'editor_docuclick' => 'Docu integration', // TRANSLATE
		'editor_enable' => 'Enable', // TRANSLATE
		'editor_plaintext' => 'Plain textarea', // TRANSLATE
		'editor_java' => 'Java editor', // TRANSLATE
		'editor_javascript' => 'JavaScript editor (beta)', // TRANSLATE
		'editor_javascript_information' => 'The JavaScript editor is still in beta stadium. Depending on which of the following options you\'ll activate, there might occur errors. Code completion is currently not working in Internet Explorer. For a complete list of known issues please have a look at the <a href="http://qa.webedition.org/tracker/search.php?project_id=107&sticky_issues=on&sortby=last_updated&dir=DESC&hide_status_id=90" target="_blank">webEdition bugtracker</a>.', // TRANSLATE


		'juplod_not_installed' => 'JUpload ei ole asennettu!',
);
